# Features

The DataStax C# Driver for Apache Cassandra is feature-rich and highly tunable Node.js client library for Apache
Cassandra (1.2+) using exclusively Cassandra's binary protocol and Cassandra Query Language v3.

## Usage

- [Address resolution](address-resolution)
- [CQL data types to C# types](datatypes)
- [Components](components)
    - [Core](components/core)
    - [Linq](components/linq)
    - [Mapper](components/mapper)
    - [ADO.NET](components/adonet)
- [Connection hearbeat](connection-heartbeat)
- [Connection pooling](connection-pooling)
- [Query warnings](query-warnings)
- [Result paging](paging)
- [Parametrized queries](parametrized-queries)
- [Routing queries](routing-queries)
- [Speculative executions](speculative-retries)
- [Tuning policies](tuning-policies)
- [User-defined functions and aggregates](udfs)
- [User-defined types](udts)