﻿//
//      Copyright (C) 2012-2016 DataStax Inc.
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//

using System;

namespace Cassandra.Serialization.Primitive
{
    internal class TimeUuidSerializer : TypeSerializer<TimeUuid>
    {
        public override ColumnTypeCode CqlType
        {
            get { return ColumnTypeCode.Timeuuid; }
        }

        public override TimeUuid Deserialize(ushort protocolVersion, byte[] buffer, int offset, int length, IColumnInfo typeInfo)
        {
            return new Guid(GuidShuffle(buffer, offset));
        }

        public override byte[] Serialize(ushort protocolVersion, TimeUuid value)
        {
            return GuidShuffle(value.ToByteArray());
        }
    }
}
